<template>
  <q-layout view="hHh lpR fFf">
    <q-header elevated>
      <Toolbar 
      :eventlogOffset="true"
      :pageTitle="$t('complete_conference.page_title')"/>
    </q-header>

    <q-page-container>
      <q-page  class="pl-fullpage">

        <q-dialog v-model="showProcessingAlert">
          <q-card>
            <q-card-section>
              <div class="text-h6">{{$t("complete_conference.processing_title")}}</div>
            </q-card-section>

            <q-card-section class="q-pt-none">
              {{$t("complete_conference.processing_message")}}
            </q-card-section>

            <q-card-actions align="right">
              <q-btn flat label="OK" color="primary" v-close-popup />
            </q-card-actions>
          </q-card>
        </q-dialog>


        <q-dialog seamless position="bottom" v-model="showAudioDialog">
          <q-card>
            <div class="q-ma-sm q-ml-sm text-bold">
              {{ currentAudio && currentAudio.name ? currentAudio.name : $t("complete_conference.nothing_playing") }}
            </div>
            <q-media-player
              autoplay
              dense
              hide-volume-slider
              hide-volume-btn
              no-video
              :source="currentAudioUrl"
              type="audio"
              color="primary"
              background-color="white"
            />
          </q-card>
        </q-dialog>

        <div v-if="fbLoading">
          {{$t("loading")}}
        </div>
        <div v-else>
          <h4 class="q-ma-md text-center">{{ conference.Name }}</h4>
          <div class="text-grey-9 text-center q-mt-lg column">
              {{ formatDateTime(conference.ActualStart || 0) }} | {{ getLengthString(conference.ActualEnd - conference.ActualStart) }}
          </div>
          <h5 class="q-ml-md q-mb-md q-mt-md">
            {{ $t("complete_conference.attendees_title") }}
          </h5>

          <ParticipationPieChart :participants="participantsWhoAttended" class="chart"/>

          <div id="session-recordings-section"
            v-if="recordings.Conference">

            <h5 class="q-ma-md">
              {{ $t("complete_conference.recordings_title") }}
            </h5>

              <q-list>
                <q-item
                  :key="index"
                  v-for="(recording, index) in recordings.Conference"
                  @click="
                    handleRecordingClick(recording, formatSessionRecordingTitle(recording, index))"
                  clickable
                  v-ripple >

                  <q-item-section avatar>
                    <q-icon name="graphic_eq" />
                  </q-item-section>

                  <q-item-section>
                    <q-item-label>
                      {{formatSessionRecordingTitle(recording, index)}}
                    </q-item-label>
                  </q-item-section>

                  <q-item-section side>
                    <q-btn
                      @click.stop="handleLinkClicked(recording)"
                      flat
                      round
                      dense
                      icon="link"
                    />
                  </q-item-section>

                </q-item>
            </q-list>
          </div>
          

          <h5 class="q-ma-md">
            {{ $t("complete_conference.participant_tracks_title") }}
          </h5>
          <q-list separator>
            <div
              bordered
              separator
              :key="phoneNumber"
              v-for="(_, phoneNumber) in recordings.Participants" >

              <q-expansion-item
                :group="phoneNumber"
                expand-separator
                icon="perm_identity"
                :label="conference.Participants[phoneNumber].Name + ' (' + phoneNumber +')'"
                header-class="text-primary" >
                
                <q-item
                  style="margin: 0px 12px 0px 12px;"
                  clickable
                  v-ripple
                  :key="index"
                  v-for="(recording, index) in recordings.Participants[phoneNumber]"
                  @click="handleRecordingClick(recording, formatParticipantRecordingTitle(recording, index, phoneNumber))">

                  <q-item-section avatar>
                    <q-icon
                      name="graphic_eq"
                      :color="currentAudio && currentAudio.upload == recording
                          ? 'green'
                          : 'black'"/>
                  </q-item-section>

                  <q-item-section>
                    <q-item-label>
                      {{formatParticipantRecordingTitle(recording, index, phoneNumber)}}                  
                    </q-item-label>
                    <q-item-label caption>
                      {{
                        $t("complete_conference.recording_ending_at", [
                          formatTime(Number(recording.Finished)),
                        ])
                      }}</q-item-label
                    > </q-item-section
                  ><q-item-section side>
                    <q-btn
                      @click.stop="handleLinkClicked(recording)"
                      flat
                      round
                      icon="link" />
                  </q-item-section>
                </q-item>
              </q-expansion-item>
            </div>
          </q-list>

          <div v-if="polls">
            <h5 class="q-ma-md">
              {{ $t("complete_conference.poll_results") }}
            </h5>
            <q-list separator>
              <div
                bordered
                separator
                :key="time"
                v-for="(_, time) in polls" >

                <q-expansion-item
                  :group="time"
                  expand-separator
                  icon="perm_identity"
                  :label="$t(polls[time].TotalVotes == 1 ? 
                    'complete_conference.poll_list_item_title_single' :  'complete_conference.poll_list_item_title',
                    [polls[time].Title, polls[time].Results ? Object.keys(polls[time].Results).length : 0])"
                  header-class="text-primary" >
                  <q-item
                  style="margin: 0px 12px 0px 12px;">
                  
                  <PollView :rawData="polls[time]" :showTitle="false" class="poll"/>

                  </q-item>
                </q-expansion-item>
              </div>
            </q-list>
          </div>

          <div style="margin-bottom:100px"></div>
        </div>
      </q-page>  
    </q-page-container>
    <q-drawer
      v-model="showEventLog"
      show-if-above
      side="right"
      :width="300"
      :breakpoint="800"
      elevated
      content-class=""
    >
      <EventLogDialog :events="conference.Events" :hostName="hostName" />
    </q-drawer>
  </q-layout>
</template>

<script>
import { db, storage } from "../firebase";
import EventLogDialog from "../components/EventLogDialog";
import ParticipationPieChart from "../components/ParticipationPieChart";
import PollView from "../components/PollView.vue";
import { DateTime } from "luxon";
import Toolbar from "../components/Toolbar.vue";

export default {
  props: ["id"],
  data() {
    return {
      showEventLog: false,
      currentAudio: null,
      currentAudioUrl: null,
      conference: {},
      showProcessingAlert: false,
      fbLoading: true,
      hostName: this.$t("loading")
    };
  },
  async created() {
    this.hostName = (await db.ref(`Users/${this.conference.Owner}/Name`).get()).val();
  },
  computed: {
    showAudioDialog: {
      get() {
        return this.currentAudioUrl !== undefined;
      },
      set() {
        this.currentAudioUrl = undefined;
      },
    },
    participantsWhoAttended() {
      let processed = {};
      for (const num in this.conference.Participants) {
        processed[num == 1000 ? this.$t("complete_conference.web_host_source") : num] = this.participantDetails(num);
      }
      return processed;
    },
    recordings() {
      if(!this.conference.Recordings) return {};

      let data = this.conference.Recordings
      
      data.Conference = this.recordingDictToOrderedList(data.Conference) || [] ;

      if(!data.Participants)
      {
        data.Participants = {};
      }
      else
      {
        Object.keys(data.Participants).forEach(key => {
          data.Participants[key] = this.recordingDictToOrderedList(data.Participants[key])
        });
      }

      return data;
    },
    polls() {
      let toRet = this.conference.Polls;
      if(!toRet) return null;

      for(let poll in toRet)
      {
        toRet[poll].TotalVotes = 0;
        toRet[poll].Options.forEach(opt => {
          toRet[poll].TotalVotes += opt.Votes ? opt.Votes.length : 0;
        });
      }

      return toRet;
    },
    audioSource() {
      return [];
    },
  },
  methods: {
    participantDetails(num)
    {
      if(num == 1000) 
      {
        let hostData = this.conference.Participants[num];
        hostData.Name = this.$t("complete_conference.web_host_name")
        return hostData;
      }

      return this.conference.Participants[num];
    },
    recordingDictToOrderedList(dict) {
      if(!dict) return null;

      let list = Object.keys(dict).map(function(key) {
        return dict[key];
      });
      list.sort(function(first, second) {
        return first.Finished - second.Finished;
      });
      return list;
    },
    formatDateTime(millis) 
    {
      return DateTime.fromMillis(millis).toFormat(
        this.$t("complete_conference.format_date_time")
      );
    },
    getLengthString(millis) 
    {
      var minutes = Math.floor((millis / (1000 * 60)) % 60),
      hours = Math.floor((millis / (1000 * 60 * 60)) % 24);

      return this.$t("complete_conference.meeting_length", [hours, minutes]);
    },
    formatSessionRecordingTitle(recording, index)
    {
      if(this.recordings.Conference.length > 1 )
      {
        return this.$t('complete_conference.main_recording_multiple', [index + 1,
          this.formatTime(Number(recording.Finished) - Number(recording.RecordingDuration)),
          this.formatTime(Number(recording.Finished))])
      }
      return this.$t('complete_conference.main_recording')
    },
    formatParticipantRecordingTitle(recording, index, phoneNumber)
    {
      return this.$t("complete_conference.participant_track_name", 
        [ this.participantDetails(phoneNumber).Name,
          index + 1,
          this.formatTime(Number(recording.Finished) - Number(recording.RecordingDuration)),
          this.formatTime(Number(recording.Finished))
        ]);                    
    },
    formatTime(millis) {
      return DateTime.fromMillis(millis).toFormat(
        this.$t("complete_conference.format_time")
      );
    },
    async handleRecordingClick(upload, name) {
      this.currentAudio = { upload, name };
      console.log(upload);
      if(upload.Upload)
      {
        const fileUrl = await storage.ref().child(upload.Upload).getDownloadURL();
        this.currentAudioUrl = fileUrl;
      }
      else
      {
        this.showProcessingAlert = true;
      }

    },
    async handleLinkClicked(recording) {
      const fileUrl = await storage.ref().child(recording.Upload).getDownloadURL();
      console.log(fileUrl)
      try {
        // Attempt to copy with the clipboard API
        await navigator.clipboard.writeText(fileUrl);
        this.$q.notify({
          message: this.$t("complete_conference.link_copied"),
        });
      } catch (err) {
        // 1) Add the text to the DOM (usually achieved with a hidden input field)
        const input = document.createElement("input");
        input.style = "display: none";
        document.body.appendChild(input);
        input.value = fileUrl;

        // 2) Select the text
        input.focus();
        input.select();

        // 3) Copy text to clipboard
        const isSuccessful = document.execCommand("copy");

        // 4) Catch errors
        if (!isSuccessful) {
          console.error("Failed to copy text.");
          this.$q.notify({
            type: "negative",
            message: this.$t("complete_conference.link_copy_failed", [fileUrl]),
          });
        }
      }
    },
    getHoursMinutesSeconds(milliSecondsIn) {
      const secondsIn = milliSecondsIn / 1000;
      const hours = Math.floor(secondsIn / 60 / 60);
      const minutes = Math.floor((secondsIn - hours * 60 * 60) / 60);
      const seconds = Math.round(secondsIn - hours * 60 * 60 - minutes * 60);
      return {
        hours,
        minutes,
        seconds,
      };
    },
  },
  watch: {
    id: {
      immediate: true,
      handler() {
        this.$rtdbBind(
          "conference",
          db.ref(`Conferences/Complete/${this.$route.params.id}`)
        ).then(() => this.fbLoading = false);
      },
    },
  },
  components: {
    EventLogDialog,
    ParticipationPieChart,
    PollView,
    Toolbar
  },
};
</script>
<style>

.q-media__controls {
  background: inherit !important;
}

.fixed-bottom .q-card {
  text-align: center;
  padding: 5px 12px 10px 12px;
}

@media only screen and (min-width: 540px) {
  .poll {
    width: 100%;
    margin: 0px auto 0px auto;
  }
}

@media only screen and (min-width: 600px) {
  .fixed-bottom .q-card {
    width: 95%;
  }

  .poll {
    width: 80%;
  }
}

#sidebar-btn {
  visibility: visible;
}

@media only screen and (min-width: 800px) {
  .fixed-bottom {
    margin-right: 300px;
  }
  #sidebar-btn {
    visibility: hidden;
  }
}

</style>